Program NETtalk;

uses CRT, DOS;

const prah = -1;
      znaky = 44;
      fonemy = 56;
      okenko = 5;
      vrstva2 = 56;
      v = 0.3;

type Aktivace = prah..1;
     V2 = array [1..vrstva2] of Real;
     V3 = array [1..fonemy] of Real;
     UkW12 = ^V2;
     UkW23 = ^V3;

var ftren, ftest, fp, fv : Text;
    fw : file of Real;
    klavesa : Char;
    slovo, fonems : String;
    znak : array [1..255] of String [2];
    fonem : array [1..255] of Char;
    sf : PathStr;
    pocet_slov, pocet_pismen, pocet_chyb : LongInt;
    i, j, k, maxfonind, vrstva1 : Integer;
    r, mom, kroky, dw, performance, maxfon : Real;
    x : array [1..okenko * znaky + 1] of Aktivace; {[1..vrstva1 + 1]}
    spravny_vystup : array [1..fonemy] of Aktivace; {[1..vrstva3]}
    suma1, vystup1, chyba1 : array [1..vrstva2 + 1] of Real; {[1..vrstva2 + 1]}
    suma2, vystup2, chyba2 : array [1..fonemy] of Real; {[1..vrstva3]}
    w1, dw1pred : array [1..okenko * znaky + 1] of UkW12; {[1..vrstva1 + 1, 1..vrstva2]}
    w2, dw2pred : array [1..vrstva2 + 1] of UkW23; {[1..vrstva2 + 1, 1..vrstva3]}

procedure inicializace;
begin ClrScr;
      randomize;
      WriteLn ('Program "NETtalk"');
      WriteLn;
      {WriteLn ('Trnovac data mus bt v souboru "tren.txt".');
      WriteLn ('Testovac data mus bt v souboru "test.txt".');}
      write ('Zadej parametr rychlosti uen: '); read (r);
      {write ('Zadej parametr podlu starho a novho: '); read (v);}
      write ('Zadej parametr momentum: '); read (mom);
      assign (ftren, 'tren.txt'); {trnovac data}
      assign (ftest, 'test.txt'); {testovac data}
      assign (fp, 'perform.txt');
      assign (fv, 'vysledek.txt');
      assign (fw, 'vahy.dat');
      vrstva1 := okenko * znaky;
      x [vrstva1 + 1] := prah;
      vystup1 [vrstva2 + 1] := prah;
      for i := 1 to vrstva1 + 1 do
      begin new (w1[i]); new (dw1pred[i]) end;
      for j := 1 to vrstva2 + 1 do
      begin new (w2[j]); new (dw2pred[j]) end;
      sf := FSearch ('vahy.dat', GetEnv ('PATH'));
      if sf = '' then
      begin kroky := 0;
            for i := 1 to vrstva1 + 1 do
            for j := 1 to vrstva2 do
            begin w1[i]^[j] := random (100) / 100 - 0.5;
                  dw1pred[i]^[j] := 0
            end;
            for j := 1 to vrstva2 + 1 do
            for k := 1 to fonemy do
            begin w2[j]^[k] := random (100) / 100 - 0.5;
                  dw2pred[j]^[k] := 0
            end;
      end
      else
      begin reset (fw);
            read (fw, kroky);
            for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do
            begin read (fw, w1[i]^[j]);
                  read (fw, dw1pred[i]^[j])
            end;
            for j := 1 to vrstva2 + 1 do for k := 1 to fonemy do
            begin read (fw, w2[j]^[k]);
                  read (fw, dw2pred[j]^[k])
            end;
      end;
      sf := FSearch ('perform.txt', GetEnv ('PATH'));
      if sf = '' then rewrite (fp) else append (fp)
end;

procedure cti_vzor;
begin for i := 1 to vrstva1 do x [i] := 0;
      for i := 1 to okenko do
      if znak [i] = 'a' then x [(i - 1) * znaky + 1] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 2] := 1 else
      if znak [i] = 'b' then x [(i - 1) * znaky + 3] := 1 else
      if znak [i] = 'c' then x [(i - 1) * znaky + 4] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 5] := 1 else
      if znak [i] = 'd' then x [(i - 1) * znaky + 6] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 7] := 1 else
      if znak [i] = 'e' then x [(i - 1) * znaky + 8] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 9] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 10] := 1 else
      if znak [i] = 'f' then x [(i - 1) * znaky + 11] := 1 else
      if znak [i] = 'g' then x [(i - 1) * znaky + 12] := 1 else
      if znak [i] = 'h' then x [(i - 1) * znaky + 13] := 1 else
      if znak [i] = 'ch' then x [(i - 1) * znaky + 14] := 1 else
      if znak [i] = 'i' then x [(i - 1) * znaky + 15] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 16] := 1 else
      if znak [i] = 'j' then x [(i - 1) * znaky + 17] := 1 else
      if znak [i] = 'k' then x [(i - 1) * znaky + 18] := 1 else
      if znak [i] = 'l' then x [(i - 1) * znaky + 19] := 1 else
      if znak [i] = 'm' then x [(i - 1) * znaky + 20] := 1 else
      if znak [i] = 'n' then x [(i - 1) * znaky + 21] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 22] := 1 else
      if znak [i] = 'o' then x [(i - 1) * znaky + 23] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 24] := 1 else
      if znak [i] = 'p' then x [(i - 1) * znaky + 25] := 1 else
      if znak [i] = 'q' then x [(i - 1) * znaky + 26] := 1 else
      if znak [i] = 'r' then x [(i - 1) * znaky + 27] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 28] := 1 else
      if znak [i] = 's' then x [(i - 1) * znaky + 29] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 30] := 1 else
      if znak [i] = 't' then x [(i - 1) * znaky + 31] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 32] := 1 else
      if znak [i] = 'u' then x [(i - 1) * znaky + 33] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 34] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 35] := 1 else
      if znak [i] = 'v' then x [(i - 1) * znaky + 36] := 1 else
      if znak [i] = 'w' then x [(i - 1) * znaky + 37] := 1 else
      if znak [i] = 'x' then x [(i - 1) * znaky + 38] := 1 else
      if znak [i] = 'y' then x [(i - 1) * znaky + 39] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 40] := 1 else
      if znak [i] = 'z' then x [(i - 1) * znaky + 41] := 1 else
      if znak [i] = '' then x [(i - 1) * znaky + 42] := 1 else
      if znak [i] = '-' then x [(i - 1) * znaky + 43] := 1 else
      {if znak [i] = ' ' then} x [(i - 1) * znaky + 44] := 1;
      for i := 1 to length (slovo) - 1 do znak [i] := znak [i + 1];
end;

procedure cti_fonem;
begin for i := 1 to fonemy do spravny_vystup [i] := 0;
      if fonem [1] = 'a' then spravny_vystup [1] := 1 else
      if fonem [1] = '' then spravny_vystup [2] := 1 else
      if fonem [1] = 'b' then spravny_vystup [3] := 1 else
      if fonem [1] = 'c' then spravny_vystup [4] := 1 else
      if fonem [1] = 'C' then spravny_vystup [5] := 1 else
      if fonem [1] = '' then spravny_vystup [6] := 1 else
      if fonem [1] = '' then spravny_vystup [7] := 1 else
      if fonem [1] = 'd' then spravny_vystup [8] := 1 else
      if fonem [1] = '' then spravny_vystup [9] := 1 else
      if fonem [1] = 'e' then spravny_vystup [10] := 1 else
      if fonem [1] = '' then spravny_vystup [11] := 1 else
      if fonem [1] = 'f' then spravny_vystup [12] := 1 else
      if fonem [1] = 'g' then spravny_vystup [13] := 1 else
      if fonem [1] = 'h' then spravny_vystup [14] := 1 else
      if fonem [1] = 'X' then spravny_vystup [15] := 1 else
      if fonem [1] = 'i' then spravny_vystup [16] := 1 else
      if fonem [1] = '' then spravny_vystup [17] := 1 else
      if fonem [1] = 'j' then spravny_vystup [18] := 1 else
      if fonem [1] = 'k' then spravny_vystup [19] := 1 else
      if fonem [1] = 'l' then spravny_vystup [20] := 1 else
      if fonem [1] = 'm' then spravny_vystup [21] := 1 else
      if fonem [1] = 'M' then spravny_vystup [22] := 1 else
      if fonem [1] = 'n' then spravny_vystup [23] := 1 else
      if fonem [1] = 'N' then spravny_vystup [24] := 1 else
      if fonem [1] = '' then spravny_vystup [25] := 1 else
      if fonem [1] = 'o' then spravny_vystup [26] := 1 else
      if fonem [1] = '' then spravny_vystup [27] := 1 else
      if fonem [1] = 'p' then spravny_vystup [28] := 1 else
      if fonem [1] = 'r' then spravny_vystup [29] := 1 else
      if fonem [1] = '' then spravny_vystup [30] := 1 else
      if fonem [1] = '' then spravny_vystup [31] := 1 else
      if fonem [1] = 's' then spravny_vystup [32] := 1 else
      if fonem [1] = '' then spravny_vystup [33] := 1 else
      if fonem [1] = 't' then spravny_vystup [34] := 1 else
      if fonem [1] = '' then spravny_vystup [35] := 1 else
      if fonem [1] = 'u' then spravny_vystup [36] := 1 else
      if fonem [1] = '' then spravny_vystup [37] := 1 else
      if fonem [1] = 'v' then spravny_vystup [38] := 1 else
      if fonem [1] = 'z' then spravny_vystup [39] := 1 else
      if fonem [1] = '' then spravny_vystup [40] := 1 else
      if fonem [1] = '' then spravny_vystup [41] := 1 else {b, f, p, v, ie - *je,  = je}
      if fonem [1] = '' then spravny_vystup [42] := 1 else {m - me,  (alt + 211) = e}
      if fonem [1] = '' then spravny_vystup [43] := 1 else {i - ij,  = j}
      if fonem [1] = 'A' then spravny_vystup [44] := 1 else {ia - ija, A = ja}
      if fonem [1] = '' then spravny_vystup [45] := 1 else {i - ij,  = j}
      if fonem [1] = 'I' then spravny_vystup [46] := 1 else {ii - iji, I = ji}
      if fonem [1] = '' then spravny_vystup [47] := 1 else {i - ij,  = j}
      if fonem [1] = 'O' then spravny_vystup [48] := 1 else {io - ijo, O = jo}
      if fonem [1] = '' then spravny_vystup [49] := 1 else {i - ij,  = j}
      if fonem [1] = 'U' then spravny_vystup [50] := 1 else {iu - iju, U = ju}
      if fonem [1] = '' then spravny_vystup [51] := 1 else {i - ij,  = j}
      if fonem [1] = 'G' then spravny_vystup [52] := 1 else {x - gz}
      if fonem [1] = 'K' then spravny_vystup [53] := 1 else {x - ks}
      if fonem [1] = 'Q' then spravny_vystup [54] := 1 else {q - kv}
      if fonem [1] = '.' then spravny_vystup [55] := 1 else
      {if fonem [1] = '_' then} spravny_vystup [56] := 1;
      for i := 1 to length (fonems) - 1 do fonem [i] := fonem [i + 1]
end;

procedure trenuj;
begin repeat kroky := kroky + 1;
             GoToXY (1, 8); write (kroky :0 :0, '. prchod trnovac dvkou');
             GoToXY (1, 10); write ('Pi trnovn st se prv zpracovv                   ');
             reset (ftren); pocet_slov := 1;
             while not SeekEOF (ftren) do
             begin GoToXY (58, 10); write (pocet_slov, '. slovo.           ');
                   pocet_slov := pocet_slov + 1;
                   ReadLn (ftren, slovo); slovo := '  ' + slovo + '  ';
                   for i := 1 to length (slovo) do znak [i] := slovo [i];
                   for i := 1 to length (slovo) do
                   begin if (znak [i] = 'c') and (znak [i + 1] = 'h') then
                         begin znak [i] := 'ch';
                               for j := i + 1 to length (slovo) - 1 do znak [j] := znak [j + 1]
                         end;
                   end;
                   ReadLn (ftren, fonems);
                   for i := 1 to length (fonems) do fonem [i] := fonems [i];
                   repeat cti_vzor; cti_fonem;
                          for j := 1 to vrstva2 do
                          begin suma1 [j] := 0;
                                for i := 1 to vrstva1 + 1 do
                                suma1 [j] := suma1 [j] + x [i] * w1[i]^[j];
                                vystup1 [j] := 1 / (1 + exp (-suma1 [j]))
                          end;
                          for k := 1 to fonemy do
                          begin suma2 [k] := 0;
                                for j := 1 to vrstva2 + 1 do
                                suma2 [k] := suma2 [k] + vystup1 [j] * w2[j]^[k];
                                vystup2 [k] := 1 / (1 + exp (-suma2 [k]));
                                chyba2 [k] := spravny_vystup [k] - vystup2 [k];
                          end;
                          for j := 1 to vrstva2 do
                          begin chyba1 [j] := 0;
                                for k := 1 to fonemy do
                                chyba1 [j] := chyba1 [j] + w2[j]^[k] * vystup2 [k] * (1 - vystup2 [k]) * chyba2 [k]
                          end;
                          for i := 1 to vrstva1 + 1 do for j := 1 to vrstva2 do
                          begin dw := r * x [i] * vystup1 [j] * (1 - vystup1 [j]) * chyba1 [j];
                                if dw * dw1pred[i]^[j] > 0
                                then w1[i]^[j] := w1[i]^[j] + dw + mom * dw1pred[i]^[j]
                                else w1[i]^[j] := w1[i]^[j] + dw;
                                dw1pred[i]^[j] := v * dw + (1 - v) * dw1pred[i]^[j]
                          end;
                          for j := 1 to vrstva2 + 1 do for k := 1 to fonemy do
                          begin dw := r * vystup1 [j] * vystup2 [k] * (1 - vystup2 [k]) * chyba2 [k];
                                if dw * dw2pred[j]^[k] > 0
                                then w2[j]^[k] := w2[j]^[k] + dw + mom * dw2pred[j]^[k]
                                else w2[j]^[k] := w2[j]^[k] + dw;
                                dw2pred[j]^[k] := v * dw + (1 - v) * dw2pred[j]^[k]
                          end;
                   until (znak [okenko - 1] = ' ') and (znak [okenko - 2] = ' ');
             end;
             performance := 0; pocet_pismen := 0; pocet_chyb := 0;
             GoToXY (1, 10); write ('Pi vpotu vkonu z trnovacch dat se prv zpracovv ');
             reset (ftren); pocet_slov := 1;
             while not SeekEOF (ftren) do
             begin GoToXY (58, 10); write (pocet_slov, '. slovo.           ');
                   pocet_slov := pocet_slov + 1;
                   ReadLn (ftren, slovo); slovo := '  ' + slovo + '  ';
                   for i := 1 to length (slovo) do znak [i] := slovo [i];
                   for i := 1 to length (slovo) do
                   begin if (znak [i] = 'c') and (znak [i + 1] = 'h') then
                         begin znak [i] := 'ch';
                               for j := i + 1 to length (slovo) - 1 do
                               znak [j] := znak [j + 1]
                         end;
                   end;
                   ReadLn (ftren, fonems);
                   for i := 1 to length (fonems) do fonem [i] := fonems [i];
                   repeat cti_vzor; cti_fonem;
                          for j := 1 to vrstva2 do
                          begin suma1 [j] := 0;
                                for i := 1 to vrstva1 + 1 do
                                suma1 [j] := suma1 [j] + x [i] * w1[i]^[j];
                                vystup1 [j] := 1 / (1 + exp (-suma1 [j]))
                          end;
                          maxfon := 0;
                          for k := 1 to fonemy do
                          begin suma2 [k] := 0;
                                for j := 1 to vrstva2 + 1 do suma2 [k] := suma2 [k] + vystup1 [j] * w2[j]^[k];
                                vystup2 [k] := 1 / (1 + exp (-suma2 [k]));
                                chyba2 [k] := spravny_vystup [k] - vystup2 [k];
                                performance := performance + chyba2 [k] * chyba2 [k];
                                if vystup2 [k] > maxfon then
                                begin maxfon := vystup2 [k];
                                      maxfonind := k
                                end;
                           end;
                           if spravny_vystup [maxfonind] <> 1 then
                           pocet_chyb := pocet_chyb + 1;
                           pocet_pismen := pocet_pismen + 1
                   until (znak [okenko - 1] = ' ') and (znak [okenko - 2] = ' ');
             end;
             write (fp, performance :0 :0, #9, pocet_chyb, #9, performance :20 :20, #9);
             GoToXY (1, 12); write ('Suma tverc odchylek = ', performance :20 :20, '        ');
             GoToXY (1, 13); write ('Podl chyb = ', 100 * pocet_chyb / pocet_pismen :0 :2, ' %  ');
             performance := 0; pocet_pismen := 0; pocet_chyb := 0;
             reset (ftest); pocet_slov := 1;
             GoToXY (1, 10); write ('Pi vpotu vkonu z testovacch dat se prv zpracovv ');
             while not SeekEOF (ftest) do
             begin GoToXY (58, 10); write (pocet_slov, '. slovo.           ');
                   pocet_slov := pocet_slov + 1;
                   ReadLn (ftest, slovo); slovo := '  ' + slovo + '  ';
                   for i := 1 to length (slovo) do znak [i] := slovo [i];
                   for i := 1 to length (slovo) do
                   begin if (znak [i] = 'c') and (znak [i + 1] = 'h') then
                         begin znak [i] := 'ch';
                               for j := i + 1 to length (slovo) - 1 do znak [j] := znak [j + 1]
                         end;
                   end;
                   ReadLn (ftest, fonems);
                   for i := 1 to length (fonems) do fonem [i] := fonems [i];
                   repeat cti_vzor; cti_fonem;
                          for j := 1 to vrstva2 do
                          begin suma1 [j] := 0;
                                for i := 1 to vrstva1 + 1 do suma1 [j] := suma1 [j] + x [i] * w1[i]^[j];
                                vystup1 [j] := 1 / (1 + exp (-suma1 [j]))
                          end;
                          maxfon := 0;
                          for k := 1 to fonemy do
                          begin suma2 [k] := 0;
                                for j := 1 to vrstva2 + 1 do suma2 [k] := suma2 [k] + vystup1 [j] * w2[j]^[k];
                                vystup2 [k] := 1 / (1 + exp (-suma2 [k]));
                                chyba2 [k] := spravny_vystup [k] - vystup2 [k];
                                performance := performance + chyba2 [k] * chyba2 [k];
                                if vystup2 [k] > maxfon then
                                begin maxfon := vystup2 [k];
                                      maxfonind := k
                                end;
                          end;
                          if spravny_vystup [maxfonind] <> 1 then
                          pocet_chyb := pocet_chyb + 1;
                          pocet_pismen := pocet_pismen + 1
                   until (znak [okenko - 1] = ' ') and (znak [okenko - 2] = ' ');
             end;
             WriteLn (fp, performance :0 :0, #9, pocet_chyb, #9, performance :20 :20, #9);
      until KeyPressed;
      close (fp); close (ftren); close (ftest)
end;

procedure vysledek;
begin rewrite (fv);
      WriteLn (fv, 'Vsledek uen neuronov st'); WriteLn (fv);
      for i := 1 to vrstva1 + 1 do
      begin for j := 1 to vrstva2 do write (fv, w1 [i]^[j] :0 :6, #9);
            WriteLn (fv)
      end;
      WriteLn (fv);
      for j := 1 to vrstva2 + 1 do
      begin for k := 1 to fonemy do write (fv, w2 [j]^[k] :0 :6, #9);
            WriteLn (fv)
      end;
      WriteLn (fv);
      WriteLn (fv, 'Vhy byly zmnny ', kroky :0 :0, ' krt.');
      Writeln;
      GoToXY (1, 15); WriteLn ('Vsledek je v souborech "vysledek.txt" a "perform.txt".');
      close (fv);
      rewrite (fw);
      write (fw, kroky);
      for i := 1 to vrstva1 + 1 do
      begin for j := 1 to vrstva2 do
            begin write (fw, w1[i]^[j]);
                  write (fw, dw1pred[i]^[j])
            end;
            dispose (w1[i]); dispose (dw1pred[i])
      end;
      for j := 1 to vrstva2 + 1 do
      begin for k := 1 to fonemy do
            begin write (fw, w2[j]^[k]);
                  write (fw, dw2pred[j]^[k])
            end;
            dispose (w2[j]); dispose (dw2pred[j])
      end;
      close (fw)
end;

begin inicializace;
      trenuj;
      vysledek
end.